
module mymod
  implicit none

  private

  integer :: local_count = 0
  real :: local_var = 0.0

  public :: sum_to_localvar , mean
  contains

    subroutine sum_to_localvar(a,b)
      implicit none
      real , intent(in) :: a
      real , intent(out) :: b

      b = a + local_var
      local_var = b
      local_count = local_count + 1
    end subroutine sum_to_localvar

    real function num_elements( ) result(a)
      implicit none
      a = real(local_count)
    end function num_elements

    real function mean( ) result(m)
      implicit none
      m = local_var/num_elements( )
    end function mean

end module mymod
